package deng.cameldemo.client;

import java.io.FileReader;

import org.apache.camel.CamelContext;
import org.apache.camel.ProducerTemplate;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TcpMsgSender {
	public static void main(String[] args) throws Exception {
		TcpMsgSender runner = new TcpMsgSender();
		runner.run(args);
	}
	
	private static Logger logger = LoggerFactory.getLogger(TcpMsgSender.class);
	public void run(String[] args) throws Exception {
		String fileName = args.length > 0 ? args[0] : "data/msg.txt";
		String[] hostPort = (args.length > 1 ? args[1] : "localhost:12345").split(":");
		String host = hostPort[0];
		String port = hostPort.length > 1 ? hostPort[1] : "12345";
		logger.info("Sending tcp message {} to host={}, port={}", new Object[]{ fileName, host, port});

		String text = IOUtils.toString(new FileReader(fileName));
		logger.debug("File size={}", text.length());
		
		CamelContext camelContext = new DefaultCamelContext();
		ProducerTemplate producer = camelContext.createProducerTemplate();
		producer.sendBody("mina:tcp://" + host + ":" + port + "?sync=false", text);
		logger.info("Message sent.");
	}
}
